package com.baeldung.mongodb;

import static org.assertj.core.api.Assertions.assertThat;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.data.mongo.DataMongoTest;
import org.springframework.test.annotation.DirtiesContext;
import org.springframework.test.context.junit.jupiter.SpringExtension;

import com.baeldung.mongodb.daos.UserRepository;
import com.baeldung.mongodb.models.User;

@ExtendWith(SpringExtension.class)
@DirtiesContext
@DataMongoTest
class MongoDbAutoGeneratedFieldIntegrationTest {

    @Autowired
    UserRepository userRepository;

    @Test
    void contextLoads() {
        // Verifies the context is loaded correctly
    }

    @Test
    void givenUserObject_whenSave_thenCreateNewUser() {

        User user = new User();
        user.setFirstName("John");
        user.setLastName("Doe");
        user.setEmail("john.doe@example.com");
        userRepository.save(user);

        assertThat(userRepository.findAll()
            .size()).isPositive();
    }

}
